apiVersion: extensions/v1beta1
kind: Deployment
metadata:
  name: app-one-backend
  labels:
    app: app-one-backend
spec:
  replicas: 2
  selector:
    matchLabels:
      app: app-one-backend
  template:
    metadata:
      labels:
        app: app-one-backend
    spec:
      containers:
      - name: app-one-backend
        image: registry.gitlab.com/daniel-svoboda/dev/app-one-backend:_VERSION_
        ports:
        - containerPort: 8080
        # readinessProbe: # if auth required will return 401 and be deemed not ready
        #   httpGet:
        #     path: /   # TODO: create /healthz endpoint with real app tests
        #     port: 8080
        resources:
          requests:
            memory: "50Mi"
            cpu: "50m"
          limits:
            memory: "500Mi"
            cpu: "700m"
        env:
        - name: DATABASE_NAME
          valueFrom:
            secretKeyRef:
              name: app-one-backend-db
              key: DATABASE_NAME

        - name: DATABASE_USER_NAME
          valueFrom:
            secretKeyRef:
              name: app-one-backend-db
              key: DATABASE_USER_NAME

        - name: DATABASE_PASSWORD
          valueFrom:
            secretKeyRef:
              name: app-one-backend-db
              key: DATABASE_PASSWORD

        - name: DATABASE_HOST
          valueFrom:
            secretKeyRef:
              name: app-one-backend-db
              key: DATABASE_HOST

        - name: DATABASE_PORT
          valueFrom:
            secretKeyRef:
              name: app-one-backend-db
              key: DATABASE_PORT

        - name: SECRET_KEY
          valueFrom:
            secretKeyRef:
              name: app-one-backend-secret-key
              key: SECRET_KEY
              
      - image: gcr.io/cloudsql-docker/gce-proxy:1.09
        name: cloudsql-proxy
        command: ["/cloud_sql_proxy", "--dir=/cloudsql",
                  "-instances=_DB-INSTANCE_=tcp:5432",
                  "-credential_file=/secrets/cloudsql/credentials.json"]
        livenessProbe:
          exec:
            command: ["nc", "-z", "127.0.0.1", "5432"]
        volumeMounts:
          - name: cloudsql-oauth-credentials
            mountPath: /secrets/cloudsql
            readOnly: true
          # - name: ssl-certs
          #   mountPath: /etc/ssl/certs
        resources:
          requests:
            memory: "20Mi"
            cpu: "20m"

      volumes:
        - name: cloudsql-oauth-credentials
          secret:
            secretName: cloudsql-oauth-credentials
        # - name: ssl-certs
        #   hostPath:
        #     path: /etc/ssl/certs

      imagePullSecrets:
      - name: gitlab-registry-auth
